=== debian/changelog ===
v4l2rtspserver (0.1.8) unstable; urgency=medium

  * Initial Release.

 -- mpromonet <michel.promonet@free.fr>  Fri, 25 Oct 2019 12:58:21 +0200
